
let t=0;
let vy0=50
let vx0=vy0
let x0=140
let y0=80
let g=9.81

let projectile= function (p){
    let width=800
    let height=300
    let dots=[] // Dots that show the projectile path
    p.end=false;
    
    p.setup = function() {
        c=p.createCanvas(Math.min(window.innerWidth,width), height);
        
        vy0t=p.createElement('span', '');
        katex.render("v_0", vy0t.elt);

        r=p.createElement('span', '');
        katex.render("\\vec{r}(t)", r.elt);
        
        vt=p.createElement('span', '');
        katex.render("v(t)", vt.elt);

        vi=p.createElement('span', '');
        katex.render("\\vec{i}", vi.elt);

        vj=p.createElement('span', '');
        katex.render("\\vec{j}", vj.elt);

        
    };
    
    // See explanations in html
    function xt(t) {
        return x0+vx0*t
    }
    function yt(t) {
        return height - (-1/2 * g * t**2 + vy0 * t + y0)
    }
    function vx(t) {
        return vx0
    }
    function vy(t) {
        return -g * t + vy0
    }

    p.v0_redraw=function(vx0,vy0){
        p.draw(p.createVector(vx0,vy0))
    }
    
    let draw_vectors=function(x,y,newV0,skiparrow=false){
        p.push()

        p.stroke(199, 141, 107)
        draw_arrow(p,x,y,x+vx(t),y-vy(t),vt,c,skiparrow)

        p.stroke(200)
        draw_arrow(p,x0,height-y0,x,y,r,c,skiparrow)

        p.stroke(121, 199, 107)
        draw_arrow(p,x0,height-y0,x0,height-y0-50,vj,c,skiparrow,true)

        p.stroke(199,119,107)
        draw_arrow(p,x0,height-y0,x0+50,height-y0,vi,c,skiparrow)

        p.stroke(181, 107, 199)
        if(newV0==null){
            draw_arrow(p,x0,height-y0,x0+vx0,height-(y0+vy0),vy0t,c,skiparrow)
        }
        else{
            draw_arrow(p,x0,height-y0,x0+newV0.x,height-(y0+newV0.y),vy0t,c,skiparrow)
        }

        p.pop()
    }
    
    
    p.draw = function(newV0=null) {
        p.clear()
        let x=xt(t)
        let y=yt(t)
        
        // Draw projectile and path
        p.push()
        p.noStroke()
        p.fill(100)
        dots.forEach((elt)=>{p.ellipse(elt[0],elt[1],5,5);})
        p.fill(0)
        p.ellipse(x,y,20,20);
        p.pop()
               
        // Draw vectors
        draw_vectors(x,y,newV0=newV0)

        p.push()
        p.stroke(0)
        p.ellipse(x0,height-y0,8)
        p.pop()
        
        // Check simulation state and update it
        if(t>50 || (height-y0)<y){
            p.end=true
            p.noLoop()
        }

        // Update state
        if(!p.end){
            t+=0.1
            dots.push([x,y])
        }
    };
    
    p.windowResized = function(){
        p.resizeCanvas(Math.min(window.innerWidth,width), height);
    }
};

refresh=function(){
    t=0
    x0=parseFloat(app.x0)
    y0=parseFloat(app.y0)
    vx0=parseFloat(app.vx0)
    vy0=parseFloat(app.vy0)
    g=parseFloat(app.g)
    p5Load()
}



project_init=function(){
    app = new Vue({
        el: '#app',
        data :{
            x0:x0,
            y0:y0,
            vy0:vy0,
            vx0:vx0,
            g:g
        },
        methods:{
            v0_redraw:function(){
                if(p5_instance.end){
                    p5_instance.v0_redraw(parseFloat(app.vx0),parseFloat(app.vy0))
                }
            }
        }
    })
    p5Load()
    
}

